#!/bin/bash

pwd

# patiets No = ???????
for Patient in ???????

do
# Getting into DT directory
cd ./${Patient}/DT/

pwd
echo "Now, running probtrackx"

cd ./modified_XTRACT_output_native/tracts/
pwd
date

for ROI in cst_l cst_r fa_l fa_r
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=3000 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"
cd ../
done

for ROI in slf1_l slf1_r slf2_l slf2_r slf3_l slf3_r cbd_l cbd_r cbp_l cbp_r cbt_l cbt_r fx_l fx_r
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=10000 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"
cd ../
done

for ROI in atr_l atr_r str_l str_r uf_l uf_r
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=1000 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"
cd ../
done

for ROI in af_l af_r or_l or_r vof_l vof_r
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=10000 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"; probtrackx2 -s  ../../../Tractography.bedpostX/merged -m  ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1   --avoid=invwarped_exclude --nsamples="10000" -x "invwarped_target.nii.gz" --waypoints="invwarped_seed.nii.gz" -o invwarped_density --forcedir --dir="../${ROI}/tractsInv"; fslmaths "invwarped_density" -add "../${ROI}/tractsInv/invwarped_density" "../${ROI}/tractsInv/invwarped_sum_density"; echo "scale=5; `cat "waytotal"` + `cat "../${ROI}/tractsInv/waytotal"` "|bc > "../${ROI}/sum_waytotal"; fslmaths "../${ROI}/tractsInv/invwarped_sum_density" -div `cat "../${ROI}/sum_waytotal"` "../${ROI}/invwarped_densityNorm"
cd ../
done

for ROI in ar_l ar_r mdlf_l mdlf_r ac
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=5000 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"; probtrackx2 -s  ../../../Tractography.bedpostX/merged -m  ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1   --avoid=invwarped_exclude --nsamples="5000" -x "invwarped_target.nii.gz" --waypoints="invwarped_seed.nii.gz" -o invwarped_density --forcedir --dir="../${ROI}/tractsInv"; fslmaths "invwarped_density" -add "../${ROI}/tractsInv/invwarped_density" "../${ROI}/tractsInv/invwarped_sum_density"; echo "scale=5; `cat "waytotal"` + `cat "../${ROI}/tractsInv/waytotal"` "|bc > "../${ROI}/sum_waytotal"; fslmaths "../${ROI}/tractsInv/invwarped_sum_density" -div `cat "../${ROI}/sum_waytotal"` "../${ROI}/invwarped_densityNorm"
cd ../
done

for ROI in ilf_l ilf_r ifo_l ifo_r mcp
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=3000 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"; probtrackx2 -s  ../../../Tractography.bedpostX/merged -m  ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1   --avoid=invwarped_exclude --nsamples="3000" -x "invwarped_target.nii.gz" --waypoints="invwarped_seed.nii.gz" -o invwarped_density --forcedir --dir="../${ROI}/tractsInv"; fslmaths "invwarped_density" -add "../${ROI}/tractsInv/invwarped_density" "../${ROI}/tractsInv/invwarped_sum_density"; echo "scale=5; `cat "waytotal"` + `cat "../${ROI}/tractsInv/waytotal"` "|bc > "../${ROI}/sum_waytotal"; fslmaths "../${ROI}/tractsInv/invwarped_sum_density" -div `cat "../${ROI}/sum_waytotal"` "../${ROI}/invwarped_densityNorm"
cd ../
done

for ROI in fma fmi
do
cd ${ROI}
probtrackx2 -s ../../../Tractography.bedpostX/merged -m ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1 --avoid=invwarped_exclude --nsamples=500 -x invwarped_seed.nii.gz --waypoints=targets.txt  -o invwarped_density --forcedir --dir=../${ROI}; fslmaths "invwarped_density" -div `cat "waytotal"` "invwarped_densityNorm"; probtrackx2 -s  ../../../Tractography.bedpostX/merged -m  ../../../Tractography.bedpostX/nodif_brain_mask -V 1 --loopcheck --opd --ompl --sampvox=1 --randfib=1   --avoid=invwarped_exclude --nsamples="500" -x "invwarped_target.nii.gz" --waypoints="invwarped_seed.nii.gz" -o invwarped_density --forcedir --dir="../${ROI}/tractsInv"; fslmaths "invwarped_density" -add "../${ROI}/tractsInv/invwarped_density" "../${ROI}/tractsInv/invwarped_sum_density"; echo "scale=5; `cat "waytotal"` + `cat "../${ROI}/tractsInv/waytotal"` "|bc > "../${ROI}/sum_waytotal"; fslmaths "../${ROI}/tractsInv/invwarped_sum_density" -div `cat "../${ROI}/sum_waytotal"` "../${ROI}/invwarped_densityNorm"
cd ../
done


cd ../../
cd ../..
done

echo "Finishing probtrackx2 process"
pwd
date

#### The setting for each tract is based on the following paper.
#### https://www.ncbi.nlm.nih.gov/pmc/articles/PMC7260058/
