#!/bin/bash

pwd

# patiets No = ???????
for Patient in ???????

do
# Getting into DT directory
cd ./${Patient}/DT/

pwd
echo "Now, running tractography stats"
date

mkdir ./modified_XTRACT_output_native/stats
cd ./modified_XTRACT_output_native/stats

mkdir Tracts_densityNorm
for ROI in ac af_l af_r ar_l ar_r atr_l atr_r cbd_l cbd_r cbp_l cbp_r cbt_l cbt_r cst_l cst_r fa_l fa_r fma fmi fx_l fx_r ifo_l ifo_r ilf_l ilf_r mcp mdlf_l mdlf_r or_l or_r slf1_l slf1_r slf2_l slf2_r slf3_l slf3_r str_l str_r uf_l uf_r vof_l vof_r
do
echo ${ROI}
cp ../tracts/${ROI}/invwarped_densityNorm.nii.gz ./Tracts_densityNorm/${ROI}.nii.gz
done

mkdir Tract_masks
for ROI in ac af_l af_r ar_l ar_r atr_l atr_r cbd_l cbd_r cbp_l cbp_r cbt_l cbt_r cst_l cst_r fa_l fa_r fma fmi fx_l fx_r ifo_l ifo_r ilf_l ilf_r mcp mdlf_l mdlf_r or_l or_r slf1_l slf1_r slf2_l slf2_r slf3_l slf3_r str_l str_r uf_l uf_r vof_l vof_r
do
echo ${ROI}.nii.gz
THR=0.05
fslmaths ./Tracts_densityNorm/$ROI.nii.gz -thr ${THR} -bin ./Tract_masks/${ROI}_mask.nii.gz
done

cd Tract_masks
fslmerge -a Tract_masks.nii.gz \
ac_mask.nii.gz \
af_l_mask.nii.gz \
af_r_mask.nii.gz \
ar_l_mask.nii.gz \
ar_r_mask.nii.gz \
atr_l_mask.nii.gz \
atr_r_mask.nii.gz \
cbd_l_mask.nii.gz \
cbd_r_mask.nii.gz \
cbp_l_mask.nii.gz \
cbp_r_mask.nii.gz \
cbt_l_mask.nii.gz \
cbt_r_mask.nii.gz \
cst_l_mask.nii.gz \
cst_r_mask.nii.gz \
fa_l_mask.nii.gz \
fa_r_mask.nii.gz \
fma_mask.nii.gz \
fmi_mask.nii.gz \
fx_l_mask.nii.gz \
fx_r_mask.nii.gz \
ifo_l_mask.nii.gz \
ifo_r_mask.nii.gz \
ilf_l_mask.nii.gz \
ilf_r_mask.nii.gz \
mcp_mask.nii.gz \
mdlf_l_mask.nii.gz \
mdlf_r_mask.nii.gz \
or_l_mask.nii.gz \
or_r_mask.nii.gz \
slf1_l_mask.nii.gz \
slf1_r_mask.nii.gz \
slf2_l_mask.nii.gz \
slf2_r_mask.nii.gz \
slf3_l_mask.nii.gz \
slf3_r_mask.nii.gz \
str_l_mask.nii.gz \
str_r_mask.nii.gz \
uf_l_mask.nii.gz \
uf_r_mask.nii.gz \
vof_l_mask.nii.gz \
vof_r_mask.nii.gz

for ROI in *_mask.nii.gz
do
ROI_BASENAME=$(basename ${ROI} _mask.nii.gz)
fslmaths ../../../dti_FA.nii.gz -mul $ROI temp_01.nii.gz
fslstats temp_01.nii.gz -M | sed -e "s/^/${ROI_BASENAME} /" >> ../FA_data.txt
fslstats temp_01.nii.gz -V | sed -e "s/^/${ROI_BASENAME} /" >> ../Volume_data.txt
rm temp_01.nii.gz
done

cat ../FA_data.txt
cat ../Volume_data.txt

cd ../../../
cd ../../
done

echo "Finishing tractography stats"
pwd
date

